#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <queue>
#include <set>
#include <array>
#include <deque>
#include <algorithm>
#include "testlib.h"
#include <random>

using namespace std;


signed main(int argc, char** argv) {
    registerGen(argc, argv, 1);
    int n = opt<int>("n");
    int m = opt<int>("m");
    int c = opt<int>("c");
    println(n, m, c);
    map <pair <int, int>, int> col;
    vector <int> vertices, order_colors;

    for (int i = 1; i < c; ++i) order_colors.push_back(i);

    mt19937 rn(rnd.next(1, 1000000000));

    shuffle(order_colors.begin(), order_colors.end(), rn);

    auto add_edge = [&](int x, int y, int color) {
        col[make_pair(x, y)] = col[make_pair(y, x)] = color;
    };
    
    vector <int> was(n + 1);

    for (int i = 0; i < c; ++i) {
        int now = rnd.next(1, n);
        while (was[now]) {
            now = rnd.next(1, n);
        }
        vertices.push_back(now);
        was[now] = 1;
    }

    for (int i = 1; i < c; ++i) {
        add_edge(vertices[i], vertices[i - 1], order_colors[i - 1]);
        for (int j = 0; j < i - 2; ++j) {
            add_edge(vertices[j], vertices[i - 1], order_colors[i - 1]);
        }
    }

    for (int i = 2; i <= n; ++i) {
        add_edge(1, i, c);
    }

    while (col.size() < m * 2) {
        int x = rnd.next(1, n), y = rnd.next(1, n);
        while (col.count(make_pair(x, y)) || x == y) {
            x = rnd.next(1, n);
            y = rnd.next(1, n);
        }
        add_edge(x, y, c);
    }

    vector <array <int, 3>> edges;
    set <int> notc;
    int xd = 0;
    for (auto i : col) {
        if (i.first.first < i.first.second) {
            edges.push_back({i.first.first, i.first.second, i.second});
            if (i.second != c) notc.insert(xd);
            ++xd;
        }
    }

    for (auto& i : edges) {
        if (rnd.next(0, 1)) swap(i[0], i[1]);
        println(i);
    }

    int q = opt<int>("q");
    println(q);
    for (int i = 0; i < q; ++i) {
        if (notc.empty()) {
            int num = rnd.next(0, m - 1);
            edges[num][2] = rnd.next(1, c);
            println(num + 1, edges[num][2]);
            if (edges[num][2] != c) notc.insert(num);
        } else {
            int num = rnd.next(0, (int)notc.size() - 1);
            auto it = notc.begin();
            while (num--) it++;
            num = *it;
            notc.erase(it);
            edges[num][2] = c;
            println(num + 1, c);
        }
    }
}
