#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;
using pi = pair<int, int>;

// O(q * ((k-1)/2)^k)
void gen_ktree(int k, int q) {
    const int n = k;
    const int m = n*(n-1)/2;
    assert(n % 2 == 1);

    cout << n << " " << m << " " << k << '\n';
    vector<vector<int>> eid(n, vector<int>(n));
    vector<vector<int>> col(n, vector<int>(n));

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            col[i][j] = col[j][i] = (i+j)%n + 1;
            eid[i][j] = eid[j][i] = ++cnt;
            cout << j+1 << " " << i+1 << " " << col[i][j] << '\n';
        }
    }

    vector<pi> que;

    while (que.size() < q) {
        int a = 0, b = 0;
        while (a == b) {
            a = rnd.next(1, k);
            b = rnd.next(1, k);
        }

        vector<int> edg_a, edg_b;
        for (int i = 0; i < n; ++i)
        for (int j = 0; j < i; ++j) {
                 if (col[i][j] == a) edg_a.push_back(eid[i][j]), col[i][j] = col[j][i] = b;
            else if (col[i][j] == b) edg_b.push_back(eid[i][j]), col[i][j] = col[j][i] = a;
        }

        assert(2*edg_a.size() == k-1);
        for (int i = 0; i < (k-1)/2; ++i) {
            const int p = edg_a[i], q = edg_b[i];
            que.emplace_back(p, b);
            que.emplace_back(q, a);
        }
    }

    que.resize(q);

    cout << que.size() << '\n';
    for (auto& [eid, col] : que) cout << eid << " " << col << '\n';
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    const string type = opt<string>(1);
    const int k = opt<int>(2);
    const int q = opt<int>(3);

    if (type == "k-tree") {
        gen_ktree(k, q);
    }
}
