#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <queue>
#include <set>
#include <array>
#include <deque>
#include <algorithm>
#include "testlib.h"

using namespace std;

signed main(int argc, char** argv) {
    registerGen(argc, argv, 1);
    int n = opt<int>("n");
    int m = opt<int>("m");
    int max_color = opt<int>("c");
    println(n, m, max_color);
    vector <pair <int, int>> edges;
    set <pair <int, int>> free;
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            free.insert(make_pair(i, j));
        }
    }
    for (int i = 0; i < m; ++i) {
        int num = rnd.next(0, (int)free.size() - 1);
        auto it = free.begin();
        while (num--) it++;
        auto edge = *it;
        free.erase(it);
        int color = rnd.next(1, max_color);
        if (rnd.next(0, 1)) swap(edge.first, edge.second);
        println(edge.first, edge.second, color);
        edges.push_back(edge);
    }
    int q = opt<int>("q");
    println(q);
    for (int i = 0; i < q; ++i) {
        int num = rnd.next(1, m);
        int col = rnd.next(1, max_color);
        println(num, col);
    }
}
