#include <iostream>
#include <vector>
#include <map>
#include "testlib.h"

using namespace std;
const int MAXN = 1e5;
const int MAXC[] = {8, 1, 2, 3, 4, 5, 6, 7, 8};

int main(int32_t argc, char** argv) {
    registerValidation(argc, argv);

    int group = stoi(validator.group());
    int n = inf.readInt(2, MAXN, "n");
    inf.readSpace();

    int m = inf.readInt(1, MAXN, "m");
    inf.readSpace();

    int c = inf.readInt(1, MAXC[group], "c");
    inf.readEoln();

    map <pair <int, int>, int> edges;
    for (int i = 0; i < m; ++i) {
        int x = inf.readInt(1, n, "x_{i}");
        inf.readSpace();
        int y = inf.readInt(1, n, "y_{i}");
        inf.readSpace();
        int col = inf.readInt(1, c, "col_{i}");

        ensuref(x != y, "x_{i} = y_{i}");
        ensuref(!edges.count(make_pair(x, y)), "Two equal edges");

        edges[make_pair(x, y)] = edges[make_pair(y, x)] = 1;
        inf.readEoln();
    }

    int q = inf.readInt(1, MAXN, "q");
    inf.readEoln();

    for (int i = 0; i < q; ++i) {
        int num = inf.readInt(1, m, "num_{i}");
        inf.readSpace();
        int col = inf.readInt(1, c, "col_{i}");
        inf.readEoln();
    }
    inf.readEof();
}
